#include <iostream>

#include "MathLib.h"

using namespace std;

void main ()
{
	cout << "--------- LIB Demo Program ---------" << endl;

	// Trigonometry
	cout << "sin 90 = " << MLSin (90.0f) << endl;
	cout << "cos 180 = " << MLCos (180.0f) << endl;
	cout << "tan 45 = " << MLTan (45.0f) << endl << endl;

	// Square/Square root
	cout << "4^2 = " << MLSquare (4) << endl;
	cout << "sqrt(16) = " << MLSquareroot (16) << endl;
	cout << "3.5^2 = " << MLSquare (3.5f) << endl;
	cout << "sqrt(12.25) = " << MLSquareroot (12.25f) << endl << endl;

	// Vectors
	MLVector3 vUp, vFoward, vRight, vUpPlusRight;

	vUp.y = 1.0f;
	vFoward.z = 1.0f;
	vRight = vUp.CrossProduct (vFoward);
	vUpPlusRight = vUp + vRight;

	cout << "Up x Foward = (" << vRight.x << ", " << vRight.y << ", " << vRight.z << ")" << endl;
	cout << "Up + Right = (" << vUpPlusRight.x << ", " << vUpPlusRight.y << ", " << vUpPlusRight.z << ")" << endl;

	cout << "------------------------------------" << endl;
}