#ifndef MATHLIB_H
#define MATHLIB_H

// Constants
const float MLPI = 3.14159f;

// Arithmetic functions
int MLSquare (int iArg_);
int MLSquareroot (int iArg_);
float MLSquare (float fArg_);
float MLSquareroot (float fArg_);

// Trigonometric functions
float MLSin (float fArg_);
float MLTan (float fArg_);
float MLCos (float fArg_);

// Vector
class MLVector3
{
public:
	float x, y, z;

	MLVector3 ();
	MLVector3 (float x_, float y_, float z_);

	float Mag ();
	void Normalize ();

	// Dot and Cross Product
	float DotProduct (MLVector3 &vArg_);
	MLVector3 CrossProduct (MLVector3 &vArg_);

	// Vector arithmetic
	MLVector3 operator + (MLVector3 vArg_);
	MLVector3 operator - (MLVector3 vArg_);
	MLVector3 operator = (MLVector3 vArg_);

	// Scalar operations
	MLVector3 operator * (float fArg_);
	MLVector3 operator / (float fArg_);
};

#endif